#ifndef ENTITY_HPP
#define ENTITY_HPP

#include <GL/glfw.h>
#include <string>

using namespace std;

struct Entity
{
	Entity();

	float x, y;
	float light;
	float color[4];
	float size;
	bool killme;

	virtual void render();
	virtual void update();
};

struct Particle : public Entity
{
	Particle(float x, float y, float xp, float yp, float size, float r, float g, float b, float decay);
	float xp, yp;
	float decay, start;
	virtual void update();
	virtual void render();
};

struct Player : public Entity
{
	Player();
	virtual void render();
	virtual void update();

	int nrBreakers;
	int breakerCountdown;
	int nrLights;
	int lightsCountdown;

	bool checkCollide(float cx, float cy);
};

struct Breaker : public Entity
{
	Breaker(float x, float y, float xp, float yp);
	float xp, yp;
	virtual void update();
};

#endif
