#ifndef MENUS_HPP
#define MENUS_HPP

#include <string>
#include <list>

using namespace std;

struct Menu
{
	Menu(const string& title);
	virtual ~Menu();

	string title;
	list<string> options;
	int sel;

	virtual void key(int k);
	virtual void draw();
	virtual void open();
};

struct MainMenu : public Menu
{
	MainMenu();
	void key(int k);
};

struct PauseMenu : public Menu
{
	PauseMenu();
	void key(int k);
	void open();
};

extern Menu* activeMenu;
extern MainMenu mainMenu;
extern PauseMenu pauseMenu;

#endif
