#include <GL/glfw.h>
#include <string>
#include <list>
#include "entity.hpp"

using namespace std;

struct World
{
	int width, height;
	double time;
	int frame;
	float percent;
	int targetpercent;
	bool goalreached;

	struct Tile
	{
		Tile() : isWall(0), isOut(0), light(0) {}

		bool isWall;
		bool isOut;
		bool isBreakable;
		float light;
		float tmpLight;
	};

	Tile* tiles;
	float* light;
	list<Entity*> things;
	Player* player;

	void render();
	void doLights();
	void update();
	bool load(const string& filename);
	void unload();

	bool trace(float x1, float y1, float x2, float y2);
	bool isFree(int x, int y);

	World();
	~World();
};

extern World world;
